TotalSilenceGlobalFunctions = TotalSilenceGlobalFunctions or {}

local TS_ChatPrefix = "TS_CHAT_PREFIX"
RegisterAddonMessagePrefix(TS_ChatPrefix)

local TS_ClientList = {}
local TS_PlayerInfo = {}

local function getPlayerSpellID()
	class, classFileName, classId = UnitClass("player")
	specID = GetSpecialization()
	
	if classId == 1 then --warrior
		return 6552
	elseif classId == 2 then -- paladin
		if specID == 1 then
			return -1
		elseif specID == 2 or specID == 3 then
			return 96231
		end
	elseif classId == 3 then -- hunter
		if specID == 1 or specID == 2 then
			return 147362
		elseif specID == 3 then
			return 187707
		end
	elseif classId == 4 then -- rogue
		return 1766
	elseif classId == 5 then -- priest
		if specID == 3 then
			return 15487
		else
			return -1
		end
	elseif classId == 6 then -- deathknight
		return 47528
	elseif classId == 7 then -- shaman
		return 57994
	elseif classId == 8 then -- mage
		return 2139
	elseif classId == 9 then -- warlock
		return -1
	elseif classId == 10 then -- monk
		if specID == 1 or specID == 2 then
			return 116705
		elseif specID == 3 then
			return -1
		end
	elseif classId == 11 then -- druid
		if specID == 2 or specID == 3 then
			return 106839
		elseif specID == 1 or specID == 4 then
			return -1
		end
	elseif classId == 12 then -- demonhunter
		return 183752
	else
		return -1
	end
end

local function getPlayerPriority()
	highest = 10
	high = 8
	medium = 6
	low = 4
	backup = 2
	class, classFileName, classId = UnitClass("player")
	specID = GetSpecialization()
	if classId == 1 then --warrior
		return medium
	elseif classId == 2 then -- paladin
		if specID == 1 then
			return 0
		elseif specID == 2 or specID == 3 then
			return medium
		end
	elseif classId == 3 then -- hunter
		if specID == 1 or specID == 2 then
			return low
		elseif specID == 3 then
			return medium
		end
	elseif classId == 4 then -- rogue
		return medium
	elseif classId == 5 then -- priest
		if specID == 3 then
			return backup
		else
			return 0
		end
	elseif classId == 6 then -- deathknight
		return medium
	elseif classId == 7 then -- shaman
		if specID == 1 or specID == 2 then
			return high
		elseif specID == 3 then
			return backup
		end
	elseif classId == 8 then -- mage
		return low
	elseif classId == 9 then -- warlock
		return 0
	elseif classId == 10 then -- monk
		if specID == 1 or specID == 2 then
			return medium
		elseif specID == 3 then
			return 0
		end
	elseif classId == 11 then -- druid
		if specID == 2 or specID == 3 then
			return medium
		elseif specID == 1 or specID == 4 then
			return 0
		end
	elseif classId == 12 then -- demonhunter
		return highest
	else
		return 0
	end
	return 0
end

local function initPlayer()
	TS_PlayerInfo.spellID = getPlayerSpellID()
	TS_PlayerInfo.priority = getPlayerPriority()
	TS_PlayerInfo.isNext = false
	TS_PlayerInfo.numClients = 0
	TS_PlayerInfo.numReadyClients = 0
	TS_PlayerInfo.nextUpdate = -1
	TS_PlayerInfo.nextHigher = -1
	TS_PlayerInfo.playerCooldown = GetSpellBaseCooldown(TS_PlayerInfo.spellID)/1000
	TS_PlayerInfo.PlayerName = GetUnitName("player")
	TS_PlayerInfo.PlayerServer = GetRealmName("player")
	if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		TS_PlayerInfo.Chat = "INSTANCE_CHAT"
		TS_PlayerInfo.ChatTarget = nil
		
		SendAddonMessage(TS_ChatPrefix,"cmd:" .. "Register" .."/" .. "prio:"..TS_PlayerInfo.priority .."/",TS_PlayerInfo.Chat,TS_PlayerInfo.ChatTarget)
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		TS_PlayerInfo.Chat = "RAID"
		TS_PlayerInfo.ChatTarget = nil
		
		SendAddonMessage(TS_ChatPrefix,"cmd:" .. "Register" .."/" .. "prio:"..TS_PlayerInfo.priority .."/",TS_PlayerInfo.Chat,TS_PlayerInfo.ChatTarget)
	else
		for unit, data in pairs(TS_ClientList) do
			if not (unit == TS_PlayerInfo.PlayerName) then
				TS_ClientList.unit = nil
			end
		end
		TS_PlayerInfo.Chat =  "WHISPER"
		TS_PlayerInfo.ChatTarget = UnitName("player")
	end
	
	TS_ClientList[TS_PlayerInfo.PlayerName] = {}
	TS_ClientList[TS_PlayerInfo.PlayerName].priority = TS_PlayerInfo.priority
	TS_ClientList[TS_PlayerInfo.PlayerName].cooldown = 0
	TS_ClientList[TS_PlayerInfo.PlayerName].control = true
	TS_PlayerInfo.dirty = true
	
end

local TS_InitEvent = CreateFrame("FRAME")
TS_InitEvent:RegisterEvent("PLAYER_ENTERING_WORLD")
TS_InitEvent:RegisterEvent("GROUP_JOINED")
TS_InitEvent:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
TS_InitEvent:SetScript("OnEvent", initPlayer)

local TS_GroupRosterEvent = CreateFrame("FRAME")
TS_GroupRosterEvent:RegisterEvent("GROUP_ROSTER_UPDATE")
TS_GroupRosterEvent:SetScript("OnEvent", function()
	if not IsInGroup() then
		initPlayer()
	end
end )


local TS_Cast_EventFrame = CreateFrame("FRAME")
TS_Cast_EventFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
local function TS_Cast_OnEvent(self, event, unitID, spell, rank, lineID, spellID)
	if unitID == 'player' then
		if spellID == TS_PlayerInfo.spellID then
			msg = "cmd:" .. "Kicked".. "/" .. "time:" .. TS_PlayerInfo.playerCooldown .. "/"
			SendAddonMessage(TS_ChatPrefix,msg,TS_PlayerInfo.Chat,TS_PlayerInfo.ChatTarget)
		end
	end
end
TS_Cast_EventFrame:SetScript("OnEvent",TS_Cast_OnEvent)

local TS_ControlFrame = CreateFrame("FRAME")
TS_ControlFrame:RegisterEvent("LOSS_OF_CONTROL_UPDATE")
TS_ControlFrame:SetScript("OnEvent", function(self, event)
	cd = GetSpellLossOfControlCooldown(TS_PlayerInfo.spellID)
	if cd == 0 then
		if not TS_ClientList[TS_PlayerInfo.PlayerName].control then
			TS_ClientList[TS_PlayerInfo.PlayerName].control = true
			TS_PlayerInfo.dirty = true
			msg = "cmd:".. "GainedControl".."/"
			SendAddonMessage(TS_ChatPrefix,msg,TS_PlayerInfo.Chat,TS_PlayerInfo.ChatTarget)
		end
	else
		if TS_ClientList[TS_PlayerInfo.PlayerName].control then
			TS_ClientList[TS_PlayerInfo.PlayerName].control = false
			TS_PlayerInfo.dirty = true
			msg = "cmd:".. "LostControl".."/"
			SendAddonMessage(TS_ChatPrefix,msg,TS_PlayerInfo.Chat,TS_PlayerInfo.ChatTarget)
		end
	end
end)

local TS_Comm_Frame = CreateFrame("FRAME")
TS_Comm_Frame:RegisterEvent("CHAT_MSG_ADDON")
local function TS_Comm_ReceiveMsg(self, event, prefix, message, channel, sender)
	if prefix == TS_ChatPrefix then
		senderName = sender
		i = string.find(senderName,"-"..TS_PlayerInfo.PlayerServer)
		if i > 0 then
			senderName = string.sub(senderName,1,i-1)
		end
		command = string.match(message,'cmd:([^/]*)/')
		if command == "Kicked" then
			timeInfo = tonumber(string.match(message,'time:([^/]*)/'))
			TS_ClientList[senderName].cooldown = GetTime() + timeInfo
			TS_PlayerInfo.dirty = true
		elseif command == "Register" then
			if not (senderName == TS_PlayerInfo.PlayerName) then
				prio = tonumber(string.match(message,'prio:([^/]*)/'))

				TS_ClientList[senderName] = {}
				TS_ClientList[senderName].priority = prio
				TS_ClientList[senderName].cooldown = 0
				TS_ClientList[senderName].control = true
				TS_PlayerInfo.dirty = true
				if (not (channel == "WHISPER"))  then
					SendAddonMessage(TS_ChatPrefix,"cmd:" .. "Register" .."/" .. "prio:"..TS_PlayerInfo.priority .."/","WHISPER",sender)
				end
			end
		elseif command == "GainedControl" then
			if not TS_ClientList[senderName].control then
				TS_ClientList[senderName].control = true
				TS_PlayerInfo.dirty = true
			end
		elseif command == "LostControl" then
			if TS_ClientList[senderName].control then
				TS_ClientList[senderName].control = false
				TS_PlayerInfo.dirty = true
			end
		end
	end
end
TS_Comm_Frame:SetScript("OnEvent",TS_Comm_ReceiveMsg)

local function calcUpdate()
	updateRequired = -1
	higherReady = -1
	higherPrioReady = false
	currTime = GetTime()
	entries = 0
	ready = 0
	for unit, data in pairs(TS_ClientList) do
		if data and data.priority > 0 and UnitIsConnected(unit) and (not UnitIsDead(unit)) and UnitInPhase(unit) then
			entries = entries+1
			if data.control then
				if currTime > data.cooldown then
					ready = ready+1
					if (data.priority > TS_PlayerInfo.priority) or ((data.priority == TS_PlayerInfo.priority) and (GetUnitName("player") > unit)) then
						higherPrioReady = true
						higherReady = currTime
					end
				else
					if updateRequired == -1 then
						updateRequired = data.cooldown
					elseif updateRequired > data.cooldown then
						updateRequired = data.cooldown
					end
					if (data.priority > TS_PlayerInfo.priority) or ((data.priority == TS_PlayerInfo.priority) and (GetUnitName("player") > unit)) then
						if higherReady == -1 then
							higherReady = data.cooldown
						elseif higherReady > data.cooldown then
							higherReady = data.cooldown
						end
					end
				end
			end
		end
	end
	TS_PlayerInfo.numClients = entries
	TS_PlayerInfo.numReadyClients = ready
	cd = GetSpellCooldown(TS_PlayerInfo.spellID)
	cd_control = GetSpellLossOfControlCooldown(TS_PlayerInfo.spellID)
	TS_PlayerInfo.nextUpdate = updateRequired
	TS_PlayerInfo.nextHigher = higherReady
	TS_PlayerInfo.isNext = ((cd == 0) and (cd_control == 0) and not higherPrioReady) 
	TS_PlayerInfo.dirty = false;
end

 TotalSilenceGlobalFunctions.getPlayerIsNext = function()
	currTime = GetTime()
	if TS_PlayerInfo.dirty then
		calcUpdate()
	elseif (currTime > TS_PlayerInfo.nextUpdate) and not (TS_PlayerInfo.nextUpdate == -1) then
		calcUpdate()
	end
	return TS_PlayerInfo.isNext
 end
 
 TotalSilenceGlobalFunctions.getNumberClients = function() 
	currTime = GetTime()
	if TS_PlayerInfo.dirty then
		calcUpdate()
	elseif (currTime > TS_PlayerInfo.nextUpdate) and not (TS_PlayerInfo.nextUpdate == -1) then
		calcUpdate()
	elseif TS_PlayerInfo.numClients == 0 then
		calcUpdate()
	end
	return TS_PlayerInfo.numClients,TS_PlayerInfo.numReadyClients
 end
 
 TotalSilenceGlobalFunctions.getTimerValues = function()
	currTime = GetTime()
	if TS_PlayerInfo.dirty then
		calcUpdate()
	elseif (currTime > TS_PlayerInfo.nextUpdate) and not (TS_PlayerInfo.nextUpdate == -1) then
		calcUpdate()
	end
	
	if TS_PlayerInfo.isNext then
		if not (TS_PlayerInfo.nextHigher == -1) then
			return TS_PlayerInfo.playerCooldown, TS_PlayerInfo.nextHigher
		end
	else
		start,duration = GetSpellCooldown(TS_PlayerInfo.spellID)
		if not (start == 0) then
			if (start + duration) < TS_PlayerInfo.nextHigher or (TS_PlayerInfo.nextHigher == -1) then
				return duration,start + duration
			end
		end
	end
	return 1,1
 end
 
TotalSilenceGlobalFunctions.getTimerEnabled = function()
	currTime = GetTime()
	if TS_PlayerInfo.dirty then
		calcUpdate()
	elseif (currTime > TS_PlayerInfo.nextUpdate) and not (TS_PlayerInfo.nextUpdate == -1) then
		calcUpdate()
	end
	
	if TS_PlayerInfo.isNext then
		if not (TS_PlayerInfo.nextHigher == -1) then
			return true
		else
			return false
		end
	else
		start,duration = GetSpellCooldown(TS_PlayerInfo.spellID)
		if not (start == 0) then
			if (start + duration) < TS_PlayerInfo.nextHigher or (TS_PlayerInfo.nextHigher == -1) then
				return true
			else
				return false
			end
		end
	end
	return false
 end
